<%
' We open the database connection at the top of the page and close it
' at the bottom of every page.  If this is too much overhead, global.asa
' and application connections can be opened.

' define the global variables
dim aid
dim zid
dim lid
dim epoch
dim cartid
dim fc_cartid
dim CookieINSTALLIDCart
dim fc_price
dim fc_retail
dim fc_onsale
dim fc_descr
dim fc_sdescr
dim fc_prodauth
dim fc_prodname
dim fc_prodpic
dim custid
custid = "INSTALLID"

' figure the unix time() equivalent
epoch = datediff("s","01/01/1970 00:00:00",Now)

' create our page wide database connection
set fp_dc = server.createobject("adodb.connection")
fp_dc.open "dsn=SYSDSN;uid=DSN_UID;pwd=DSN_PW"

'#######################################################

function fc_open()
 cookievalue = request.cookies("CookieINSTALLIDCart")
 if cookievalue <> "" then
  fc_values = Split( cookievalue, ":" )
  fc_cartid = fc_values(0)
  zid       = fc_values(1)
  lid       = fc_values(2)
 else
  fc_cartid = ""
 end if
 aid = request.querystring("aid")

 if not zid then
  ' get the default zone and language
  set fp_rs = fp_dc.execute("select zoneid from MASTERTABLE")
  if not fp_rs.eof then 
   zid=fp_rs("zoneid")
  else
   ' something is wrong, so just default
   zid=1
  end if
  fp_rs.close : set fp_rs = nothing
 end if

 if not lid then
  ' zone given, not language; get the default language for the given zone
  set fp_rs = fp_dc.execute( _
   "select zonedeflid from ZONETABLE where zoneid=" & zid );
  if not fp_rs.eof then 
   lid=fp_rs("zonedeflid")
  else
   lid=1
  end if
  lang_iso = "";
  fp_rs.close : set fp_rs = nothing
 end if

 ' get ISO 639/2 code for this language
 if lang_iso <> 0 then
  set fp_rs = fp_dc.execute( _
   "select langiso from LANGTABLE where langid=" & lid );
  if not fp_rs.eof then
   lang_iso=fp_rs("langiso")
   fp_rs.close : set fp_rs = nothing
  end if
 end if

 if fc_cartid <> "" then      ' cookie set; see if the order is valid 
  set fp_rs = fp_dc.execute( _
    "select aid from ORDERHEAD where orderid='" & fc_cartid & "'")
  if fp_rs.eof then ' the order does not exist
   fc_cartid = ""
  else
   ' the database return is a padded string of blanks if
   ' the string was empty when inserted in the database
   aid = replace(aid, " ", "" )
   fc_aid = replace(fp_rs("aid"), " ", "" )
   if aid <> "" and fc_aid = "" then
    ' if aid is not null and the order aid is null,
    ' update this aid into the order header
    fp_dc.execute( _
     "update ORDERHEAD set aid='"&aid&"' where orderid='"&fc_cartid&"'")
    fp_dc.execute("commit work")
   end if
  end if
  fp_rs.close : set fp_rs = nothing
 end if

 if aid = "" then
  aid = "DEFAULT_AID"
 end if

 if fc_cartid = "" then
  ' if the cookie was no good or did not exist, we open a new order
  ' the aid is taken from the first time it is given to us and 
  ' never updated after that even if it is different

  set fp_rs = fp_dc.execute("call order_INSTALLIDins")
  fc_cartid = left ( cstr(rnd() * 1000000000000), 10 )

  Mn  = cstr( DatePart("M",Now) )
  Dy  = cstr( DatePart("d",Now) )
  Sq  = cstr( fp_rs("cartid_seq") )

  lMn = Len( Mn )
  lDy = Len( Dy )
  lSq = Len( Sq )

  zMn = Left( "0", 2 - lMn ) & Mn
  zDy = Left( "0", 2 - lDy ) & Dy
  zSq = Left( "0000000", 7 - lSq ) & Sq

  fc_cartid = DatePart("yyyy",Now) & zMn & zDy & zSq

  fp_rs.close 
  set fp_rs = nothing

  fp_dc.execute("insert into ORDERHEAD (custid,orderid,zone,subz,tstamp,contrib,trans1,aid,complete) values ('" & custid & "','" & fc_cartid & "'," & zid & ",0," & epoch & ",0,'" & trans1 & "','" & aid & "',0)")

  fp_dc.execute("commit work")

  ' set a 48 hour cookie
  cookievalue = fc_cartid & ":" & zid & ":" & lid
  response.cookies("CookieINSTALLIDCart") = cookievalue
  response.cookies("CookieINSTALLIDCart").domain = ".DOMAIN.TLD"
  response.cookies("CookieINSTALLIDCart").path = "/"
  response.cookies("CookieINSTALLIDCart").expires = dateadd("h",48,now)
 end if
end function

'###################################################

function fc_close()
 fp_dc.close
end function

'###################################################

function getprice ( zid, sku )
 set fp_rs = fp_dc.execute("select prodsalebeg,prodsaleend,prodsaleprice,prodprice,prodrtlprice from PRODTABLE where prodsku='" & sku & "' and prodzid=" & zid )

 if not fp_rs.eof then 
  fc_retail=fp_rs("prodrtlprice")
  if fp_rs("prodsalebeg") < epoch and epoch < fp_rs("prodsaleend") then
   fc_price=fp_rs("prodsaleprice")
   fc_onsale=1
  else
   fc_price=fp_rs("prodprice")
   fc_onsale=0
  end if
 else
  fc_price=0 : fc_retail=0 : fc_onsale=0
 end if

 fp_rs.close
 set fp_rs = nothing
end function

'###################################################

function getpricedescr ( zid, lid, sku )
 ' set fp_dc = server.createobject("adodb.connection")
 ' get the language independent pieces
 set fp_rs = fp_dc.execute("select prodsalebeg,prodsaleend,prodsaleprice,prodprice,prodrtlprice from PRODTABLE where prodsku='" & sku & "' and prodzid=" & zid)
 if not fp_rs.eof then 
  fc_retail=fp_rs("prodrtlprice")
  if fp_rs("prodsalebeg") < epoch and epoch < fp_rs("prodsaleend") then
   fc_price=fp_rs("prodsaleprice")
   fc_onsale=1
  else
   fc_price=fp_rs("prodprice")
   fc_onsale=0
  end if
 else
  fc_price=0 : fc_retail=0 : fc_onsale=0
 end if

 fp_rs.close
 set fp_rs = nothing

 ' get the language dependent pieces
 set fp_rs = fp_dc.execute("select prodsdescr,proddescr,prodpic,prodauth,prodname from PRODLANG where prodlsku='" & sku & "' and prodlid=" & lid & " and prodlzid=" & zid)
 if not fp_rs.eof then 
  fc_descr =fp_rs("proddescr")
  fc_sdescr=fp_rs("prodsdescr")
  fc_prodpic=fp_rs("prodpic")
  fc_prodauth=fp_rs("prodauth")
  fc_prodname=fp_rs("prodname")
 else
  fc_descr="" : fc_sdescr=""
 end if
 fp_rs.close
 set fp_rs = nothing
end function

'##################################################

function addproduct(cartid, product, quantity)
 ' see if this product is already on order
 set fp_rs = fp_dc.execute("select qty from ORDERLINE where orderid='" & _
      cartid & "' and sku='" & product & "'")
 if not fp_rs.eof then 
  ' product is already on order, see if there is sufficient inventory
  set fq_rs = fp_dc.execute("select prodinvqty,produseinvq,prodordmax," & _
      "prodflag1 from PRODTABLE where prodsku='" & product & "'")
  if not fq_rs.eof then 
   fc_use=fq_rs("produseinvq")
   fc_inv=fq_rs("prodinvqty")
   fc_ordmax=fq_rs("prodordmax")
   fq_rs.close
   set fq_rs = nothing

   if fc_ordmax > 0 and quantity > fc_ordmax then
    ' can't order more than max; check before inventory
    fc_quantity = fc_ordmax
   end if
   if use and quantity>fc_inv then
    set fq_rs = fp_dc.execute("update ORDERLINE set qty=" & fc_inv & "," & _
        "invover=1 where orderid=' & cartid & ' and sku=' & product & '")
   else
    set fq_rs = fp_dc.execute("update ORDERLINE set qty=" & quantity & ", invover=0 where orderid='" & cartid & "' and sku='" & product & "'")
   end if
   fp_dc.execute("commit work")
  end if
  fp_rs.close
  set fp_rs = nothing

 else 
  ' product is not on order, see if there is sufficient inventory
  set fp_rs = fp_dc.execute("select prodprice,prodinvqty,produseinvq,prodordmax,prodflag1 from PRODTABLE where prodsku='" & product & "'")

  if not fp_rs.eof then 
   fc_price=fp_rs("prodprice")
   fc_use=fp_rs("produseinvq")
   fc_inv=fp_rs("prodinvqty")
   fc_ordmax=fp_rs("prodordmax")
   fp_rs.close
   set fp_rs = nothing
  end if

  if fc_ordmax and quantity > fc_ordmax then
   ' can't order more than max; check before inventory
   quantity = fc_ordmax
  end if

  randomize
  ' generate a random number twixt 1 and 2GB+1 for order line id
  olid = int(1000000000 * rnd)+1

  if use>0 and quantity>0 and quantity>fc_inv then

   fp_dc.execute("insert into ORDERLINE (custid,orderid,sku,compsku,qty,invover,olzone,ollang,olprice,olid) values ('" & custid & "','" & cartid & "','" & product & "','" & product & "'," & fc_inv & ",0," & zid & "," & lid & "," & fc_price & "," & olid & ")")

  else if quantity > 0  then

   fp_dc.execute("insert into ORDERLINE (custid,orderid,sku,qty,invover,compsku,olzone,ollang,olprice,olid) values ('" & custid & "','" & cartid & "','" & product & "'," & quantity & ",0,'" & product & "'," & zid & "," lid & "," & fc_price & "," & olid & ")" ) 

  end if
 end if
 end if
 ' fp_dc.close
end function

'######################################################

fc_open()  ' start a new order if needed
%>
